/*
** Module   : MenuDefinition.java
** Abstract : An abstract class. Its implementation will described concrete menu definition. 
**
** Copyright (c) 2014, Golden Code Development Corporation.
** ALL RIGHTS RESERVED. Use is subject to license terms.
**
**           Golden Code Development Corporation
**                      CONFIDENTIAL
**
** -#- -I- --Date-- ---------------------------------Description---------------------------------
** 001 VIG 20141114 Created initial version.
*/
package com.goldencode.p2j.ui;


/**
 * Base class for menu definitions. One implementation for each menu.
 */
public abstract class MenuDefinition
extends WidgetListBase<MenuWidget>
{
   /**  
    * Link to menu widget, that this definition relates to. 
    */
   private MenuWidget self;
   
   /**
    * Get self menu widget.
    * 
    * @return   See above.
    */
   public MenuWidget getSelf()
   {
      return self;
   }

   /**
    * Get self menu widget.
    * 
    * @param   self
    * @throws  IllegalStateException
    *          If self is already initialized.
    */
   public void setSelf(MenuWidget self)
   {
      if (this.self != null) 
         throw new IllegalStateException("Self menu widget is already initialized.");
      
      this.self = self;
   }
}
